
%{
  open Gram
%}

%token PROD BAR SEMI EOF
%token <string> STRING
%token <string> IDENT

%start grammar
%type < Gram.non_terminal * Gram.rule list > grammar

%%
grammar:
  rules EOF { let r = List.flatten $1 in
	      let s = fst (List.hd r) in
	      (s, r) }
;
rules:
  rule            { [$1] }
| rule SEMI       { [$1] }
| rule SEMI rules { $1 :: $3 }
;
rule:
  IDENT PROD productions { List.map (fun p -> ($1,p)) $3 }
;
productions:
  production                 { [$1] }
| production BAR productions { $1 :: $3 }
;
production:
  /* epsilon */     { [] }
| letter production { $1 :: $2 }
;
letter:
  IDENT  { NonTerminal $1 }
| STRING { Terminal $1 }
;
%%
