
open Gram

(*s LR(0) and SLR(1) analyzers. *)

type simple_item = non_terminal * (letter list * letter list)

module Iset : Set.S with type elt = simple_item

type simple_state = Iset.t

module Smap : Map.S with type key = simple_state

type action = simple_state Pushdown.action

module Aset : Set.S with type elt = action

type lr0_automaton = {
  lr0_start : simple_state;
  lr0_actions : Aset.t Tmap.t Smap.t;
  lr0_gotos : simple_state Ntmap.t Smap.t
}

val no_conflict : lr0_automaton -> bool

val run_lr0 : lr0_automaton -> terminal list -> bool

val lr0 : Gram.t -> lr0_automaton

val slr1 : Gram.t -> lr0_automaton

(*s LALR(1) and LR(1) *)



val analyze_lr0 : Gram.t -> unit
val analyze_slr1 : Gram.t -> unit

