
open Gram

type 's action = 
  | Success
  | Shift of 's
  | Reduce of rule

exception Error

type 's automaton = {
  start: 's * non_terminal;
  actions: 's -> terminal -> 's action;
  gotos: 's -> non_terminal -> 's;
}

let rec unstack l1 l2 = match l1, l2 with
  | [], _ -> l2
  | x1 :: l1, (_,x2) :: l2 -> assert (x1 = x2); unstack l1 l2
  | _, [] -> assert false
  
let run aut w =
  let rec loop stack w = match stack, w with
    | _, [] -> 
	raise Error
    | [], _ ->
	assert false
    | (s,_) :: _, a :: w -> match aut.actions s a with
	| Success -> ()
	| Shift s' -> loop ((s', Terminal a) :: stack) w
	| Reduce (n,p) -> match unstack (List.rev p) stack with
	    | (s',_) :: _ as stack -> 
		loop ((aut.gotos s' n, NonTerminal n) :: stack) w
	    | [] -> assert false
  in
  loop [let s,n = aut.start in s, NonTerminal n] w
