
(* Pretty-print of tables. *)

module type TypeWithPrinter = sig
  type t
  val pp : t -> string
end

module type S = sig
  type t
  val pp_table : t -> unit
  val pp_latex_table : t -> string -> unit
end

module Make 
  (A : TypeWithPrinter)
  (B : TypeWithPrinter)
  (C : TypeWithPrinter)
  (Amap : Map.S with type key = A.t)
  (Bmap : Map.S with type key = B.t) :
  S with type t = C.t Bmap.t Amap.t
